local NpcHide = CreateFrame("Frame", "NpcHideFrame", nil)
local lastSetting = ""
local BlizzardTexture = "Interface\\MiniMap\\ObjectIconsAtlas"
local HideNPCTexture = "Interface\\AddOns\\HideNpcTracking\\NPC"
local HideFriendlyTexture = "Interface\\AddOns\\HideNpcTracking\\NPC-FRIEND"
local BlizzardTextureNoArrows = "Interface\\AddOns\\HideNpcTracking\\NA"
local HideNPCTextureNoArrows = "Interface\\AddOns\\HideNpcTracking\\NPC-NA"
local HideFriendlyTextureNoArrows = "Interface\\AddOns\\HideNpcTracking\\NPC-FRIEND-NA"


SLASH_NPCHIDE1, SLASH_NPCHIDE2 = '/hide', '/hide';
local function slashhandler(msg, editbox)

	if (msg == 'npc') then
		_HideNPC.setting = 'npc'
		if editbox then print('Hiding NPCs') end
	elseif (msg == 'friendly') then
		_HideNPC.setting = 'friendly'
		if editbox then print('Hiding NPCs and friendly players') end
	elseif (msg == 'reset') then
		_HideNPC.setting = nil
		_HideNPC.arrows = nil
		if editbox then print("Hiding settings reset") end
	elseif (msg == 'arrows') then
		_HideNPC.arrows = 'hide'
		if editbox then print("Hiding arrows") end
	else
		print('hidenpc: valid commands:')
		print('1: /hide npc')
		print('2: /hide friendly')
		print('3: /hide arrows')
		print('4: /hide reset')	
	end
	hide()
end

function hide()

	if not _HideNPC.setting then
		if not _HideNPC.arrows then
			Minimap:SetBlipTexture(BlizzardTexture)
		else
			Minimap:SetBlipTexture(BlizzardTextureNoArrows)
		end
		return
	end

	if not _HideNPC.arrows then
		if(_HideNPC.setting == 'npc') then
			Minimap:SetBlipTexture(HideNPCTexture)
		end
		
		if(_HideNPC.setting == 'friendly') then
			Minimap:SetBlipTexture(HideFriendlyTexture)
		end		
	elseif _HideNPC.arrows == 'hide' then
		if(_HideNPC.setting == 'npc') then
			Minimap:SetBlipTexture(HideNPCTextureNoArrows)
		end
		
		if(_HideNPC.setting == 'friendly') then
			Minimap:SetBlipTexture(HideFriendlyTextureNoArrows)
		end		
	end

end

SlashCmdList["NPCHIDE"] = slashhandler;

local function onEvent(self, event, addonName, ...)
	
	if (event == "ADDON_LOADED" and addonName == "HideNpcTracking") then
	
		if _HideNPC == nil then
			_HideNPC = {
				["setting"] = "npc"
			}
		end
		
		hide()
		
	end
	
end

NpcHide:RegisterEvent("ADDON_LOADED")
NpcHide:SetScript("OnEvent", onEvent)